<template>
  <el-input placeholder="ค้นหา.." v-model="filterText"> </el-input>
  <el-tree
    class="filter-tree mt-3"
    :data="stargics"
    :props="defaultProps"
    default-expand-all
    :filter-node-method="filterNode"
    ref="tree"
    node-key="id"
    empty-text="ไม่พบข้อมูล"
  >
    <template #default="{ node, data }">
      <span>
        <p :class="data.children && data.children.length > 0 && ` font-bold`">
          {{ node.label }}
          <small
            v-if="data.children && data.children.length > 0"
            class="text-gray-500"
          >
            ( {{ data.children.length }}
            โครงการ )
          </small>
        </p>
        <span v-if="!data.children || data.children.length == 0">
          <button
            @click="clickOpenDialog(data)"
            class="text-blue-600 text-xs focus:outline-none hover:underline"
          >
            ดูข้อมูล
          </button>
          <a
            :href="data.link"
            v-if="data.link"
            class="text-blue-600 text-xs focus:outline-none hover:underline"
          >
            ข้อมูลสรุป
          </a>
        </span>
      </span>
    </template>
  </el-tree>
  <detail-project-dialog
    :project="project"
    :open="dialog"
    @close="dialog = false"
    :windowWidth="width"
    :typWindow="type"
  />
</template>

<script>
import { computed, onMounted, onUnmounted, reactive, ref, watch } from "vue";
import DetailProjectDialog from "./Welcome/DetailProjectDialog.vue";
export default {
  components: { DetailProjectDialog },
  props: {
    stargics: Array,
  },
  setup() {
    const filterText = ref(null);
    const tree = ref(null);
    const defaultProps = reactive({
      label: "name",
      children: "children",
    });
    const filterNode = (value, data) => {
      if (!value) return true;
      return data.name.indexOf(value) !== -1;
    };
    watch(filterText, (val) => {
      tree.value.filter(val);
    });

    const project = ref({});
    const dialog = ref(false);
    const clickOpenDialog = (p) => {
      project.value = p;
      dialog.value = true;
    };

    const windowWidth = ref(window.innerWidth);
    const onWidthChange = () => (windowWidth.value = window.innerWidth);
    onMounted(() => window.addEventListener("resize", onWidthChange));
    onUnmounted(() => window.removeEventListener("resize", onWidthChange));

    const type = computed(() => {
      if (windowWidth.value <= 640) return "sm";
      if (windowWidth.value <= 768) return "md";
      if (windowWidth.value <= 1024) return "lg";
      if (windowWidth.value <= 1280) return "xl";
      if (windowWidth.value >= 1536) return "2xl";
    });

    const width = computed(() => windowWidth.value);

    return {
      project,
      dialog,
      clickOpenDialog,
      type,
      width,
      defaultProps,
      tree,
      filterText,
      filterNode,
    };
  },
};
</script>

<style>
.el-tree-node {
  white-space: pre-wrap;
}
.el-tree-node__content {
  height: auto;
  width: 100%;
}
</style>
